﻿/*
Данный скрипт устанавливает левый отступ для выделенных строк
текста так, чтобы самая длинная строчка блока оказалась по центру
фрейма.
Практическое применение - верстка стихов, которые надо оставлять с
выключкой в левый край, но ставить по центру полосы.

(c) Евгений Трефилов, 2007 | e-mail: evgenyt@nwgsm.ru

Особая благодарность Максиму Стринжа за помощь и консультации :pray:
*/

if ((app.selection.length == 0) || (app.selection[0].constructor.name != "Text"))
{
alert ("Please select some text with Text tool");
}

else

{
myLines=app.selection[0].lines;

var maxLength;
maxLength=0;
//finding longest line among selected
	for (myCounter = 0; myCounter < myLines.length; myCounter++) {

	currentLength=calculateLineLength(myLines.item(myCounter));
	if (currentLength > maxLength)
{
maxLength=currentLength;
}
}
	
//getting width of frame

myFrame = app.selection[0].parentTextFrames[0];
 
myFrameWidth = myFrame.geometricBounds[3]-myFrame.geometricBounds[1];

//calculating indent

myLeftIndent = (myFrameWidth - maxLength)/2;

//applying

	for (myCounter = 0; myCounter < myLines.length; myCounter++) {
	myLines.item(myCounter).leftIndent=myLeftIndent;
	}
}

function calculateLineLength (myLine)
{ 
myLength = myLine.characters.lastItem().horizontalOffset - myLine.characters.firstItem().horizontalOffset;
return (myLength);
}
